<?php

 ########################################################################################
 # This option limits the number of directories to display for a file. e.g. if we set   #
 # this to 5, and the file is located in "/i/am/in/a/long/dir/name/for/you/to/find" you #
 # would only see "name/for/you/to/find" as the directory that is displayed. on the     #
 # search page                                                                          #
$search_cutdn_depth      =5;#############################################################

 ########################################################################################
 # if the directory name (after being limited by the variable above) is longer than this#
 # many characters long we will want to cut it down.  To disable this optiont just set  #
 # it to some ridiculously high number (e.g. 10000)                                     #
$search_truncdn_iflength =28;############################################################

 ########################################################################################
 # if we need to cut the directory name, how many characters should we trim it down to  #
 # (the characters will be trimmed off the beginning of the directory name)             #
$search_truncdn_tolength =25;############################################################

 ########################################################################################
 # if we have to trim a directory name this is the string we would put in front of it   #
 # (so that your searching users have some signifier telling them that it has been cut) #
$search_truncdn_prefix   ='...';#########################################################

 ########################################################################################
 # if we have to trim a directory name this is the string we would put in back of it    #
 # (so that your searching users have some signifier telling them that it has been cut) #
$search_truncdn_suffix   ='';############################################################

 ########################################################################################
 # if a filename is longer than this many characters we will trim it (in the same       #
 # fashion as we did the directories)                                                   #
$search_truncfn_iflength =28;############################################################

 ########################################################################################
 # how many characters to trim the filename down to                                     #
$search_truncfn_tolength =25;############################################################

 ########################################################################################
 # if we have to trim a directory name this is the string we would put in front of it   #
 # (so that your searching users have some signifier telling them that it has been cut) #
$search_truncfn_prefix   ='...';#########################################################

 ########################################################################################
 # place this string at the end of any filename that has been trimmed down because it   #
 # is too long                                                                          #
$search_truncfn_suffix   ='';############################################################

 ########################################################################################
 # you shouldnt change this unless you're mean and evil and want to purposely confuse   #
 # your users by starting their search results somewhere in the middle. why do i have   #
 # it here as an option? because i'm too lazy to take it out!                           #
$search_default_offset   =0;#############################################################

 ########################################################################################
 # the default fileize units to display.  valid options are kb (kilobyte), mb (megabyte #
 # gb (gigabyte), and tb (terrbyte) (yea, right...) any other seting will results in    #
 # the usage of bytes.  This setting is NOT always going to be accurate.  It depends    #
 # on the remote FTP server representing the filesize correctly, and in bytes           #
$search_display_units    ='kb';##########################################################

 ########################################################################################
 # should the searching mechanism filter out words specified as bad? 0=no 1=yes.  See   #
 # $search_censor_word to set the list of excluded words                                #
$search_censor           =0;#############################################################

 ########################################################################################
 # a list of words which a user will not be allowed to search for.  If a search is sub- #
 # mitted with any of these words in it the word will, quite simply, be removed from    #
 # the search query.  It just dissappears. Add as many of these as you like... (this    #
 # setting has _NO_ effect unless $search_censor is set to 1.  This is by NO MEANS 100% #
 # effective due to simplistic and literal matching... "amn" will retrieve results with #
 # the word "damn" even though "damn" might be censored by this setting... this also    #
 # censors part of a word... so searching for "sexual" when "sex" is censored would     #
 # result in searching for "ual".  This setting is also case INsensative. meaning that  #
 # "warez" == "Warez" == "WAREZ" == "wArEz".                                            #
$search_censor_word[] ='porn';                                                          # 
$search_censor_word[] ='sex';                                                           #
$search_censor_word[] ='warez';                                                         #
$search_censor_word[] ='mp3';############################################################

?>
