<?php
 /* The location of the files since its better to keep these types of things
 out of your web root -- if it can be at all helped. */

 $conf_path  = "config/";
 $templ_path = "templates/";
 $class_path = "classes/";
 $funct_path = "functions/";

 /* Configure our templating engine, and feed it our defaults */
 include($class_path."class.FastTemplate.php3");
 include($class_path."class.Queue.php");
 include($class_path."class.Search.php");
 include($conf_path."display.php");
 include($conf_path."search.php");
 include($conf_path."mysql.php");
 include($conf_path."backup.php");
 include($conf_path."indexer.php");
 include($conf_path."templates.php");
 include($conf_path."authentication.php");
 include($funct_path."encode.php");
 include($funct_path."time.php");

 $tpl = new FastTemplate($templ_path);
 $tpl->define($Templates);
 $tpl->assign($Display);

 function sanitize($string) {
	$string=str_replace(chr(34), '', $string);
	$string=str_replace(chr(39), '', $string);
	$string=str_replace(chr(44), '', $string);
	$string=str_replace(chr(59), '', $string);
	$string=str_replace(chr(61), '', $string);
	return($string);
 }

 function sqlconnect($mysql) {
	if ( is_array($mysql) ) {
		$conn=@mysql_pconnect($mysql['host'], $mysql['user'], $mysql['pass']);
		if ( $conn && mysql_select_db($mysql['dbas']) ) {
		        return($conn);
		} else {
		        return(NULL);
		}
	}
 }

 switch($_GET["PageAction"]) {
  case "queue": 
	if ( $RequireQueuePass == 1 ) {
		if ($_SERVER['PHP_AUTH_USER'] != $QueueUser || $_SERVER['PHP_AUTH_PW'] != $QueuePass) {
                        header('WWW-Authenticate: Basic realm="Please Authenticate"');
                        header('HTTP/1.0 401 Unauthorized');
                        exit;
		}		
	}
	$tpl->assign(PageTitle, "Queue An FTP Site");
	if ( !isset($_POST['formaction']) ) {
		$tpl->parse(PageB, "queue");
	} else {
		switch ($_POST['formaction']) {
			case "queueblanks":
				$nq_user=$_POST['blank'][0];
				$nq_pass=$_POST['blank'][1];
				$nq_host=$_POST['blank'][2];
				$nq_port=$_POST['blank'][3];
				$nq_mail=$_POST['emailaddr'];
				$nq_url='ftp://';
				if ( !empty($nq_user) ) {
					$nq_url.=$nq_user.':'.$nq_pass.'@';
				}
				$nq_url.=$nq_host;
				if ( !empty($nq_port) ) {
					$nq_url.=':'.$nq_port;
				}
				$nq_url.='/';
				$queue=new queue($mysql['host'], $mysql['user'], $mysql['pass'], $mysql['dbas'], $indexer[lifespan]);
				$queue->handle_queue(sanitize($nq_url), sanitize($_POST['emailaddr']));
				break;
			case "queueurl":
				$queue=new queue($mysql['host'], $mysql['user'], $mysql['pass'], $mysql['dbas'], $indexer[lifespan]);
				foreach ( $_POST['URL'] as $idx ) {
					if ( !empty($idx) ) {
						$queue->handle_queue(sanitize($idx), sanitize($_POST['emailaddr']));
					}
				}
				break;
		};
		$tpl->parse(PageB, "queue-result");
	}
	break;
  case "search": 
        if ( $RequireSearchPass == 1 ) {
		$pass=0;
		foreach ( $SearchUser as $idx => $val ) {
			if ( $_SERVER['PHP_AUTH_USER'] == $idx && $_SERVER['PHP_AUTH_PW'] == $val ) {
				$pass=1;
			}
		}
                if ( $pass == 0 ) {
                        header('WWW-Authenticate: Basic realm="Please Authenticate"');
                        header('HTTP/1.0 401 Unauthorized');
                        exit;
                }
        }
	$time_start = getmicrotime();
	$tpl->assign(PageTitle, "FTP Search");
	if ( !isset($_POST['formaction']) && !isset($_GET['sterms']) ) {
		$tpl->assign(SearchTerms, '');
		$tpl->parse(PageB, "search");
	} else {
		if ( $search_censor == 1 ) {
			if ( is_array($search_censor_word) ) {
				foreach ( $search_censor_word as $word ) {
					$_POST['sterms']=eregi_replace($word,'',$_POST['sterms']);
					$_GET['sterms']=eregi_replace($word,'',$_GET['sterms']);
				}
			}
		}
		switch ($_POST['formaction']) {
			case "search":
				$tpl->assign(SearchTerms, $_POST['sterms']);
				$tpl->assign(DefaultSearchLimit, $_POST['limit']);
				if ( !empty($_POST['sterms']) ) {
					$search=new search($mysql, $conf_path);
					$res=$search->ftpsearch(sanitize($_POST['sterms']), sanitize($_POST['limit']), sanitize($_POST['offset']), sanitize($_POST['units']));
				}
				break;
		};
		if ( isset($_GET['sterms']) ) {
			switch ($_GET['sterms']) {
				default:
					if ( !empty($_POST['sterms']) ) {
						$tpl->assign(SearchTerms, $_POST['sterms']);
						$tpl->assign(DefaultSearchLimit, $_POST['limit']);
					} else {
						$tpl->assign(SearchTerms, $_GET['sterms']);
						$tpl->assign(DefaultSearchLimit, $_GET['limit']);
					}
					if ( !empty($_GET['sterms']) ) {
						$search=new search($mysql, $conf_path);
						$res=$search->ftpsearch(sanitize($_GET['sterms']), sanitize($_GET['limit']), sanitize($_GET['offset']), sanitize($_GET['units']));
					}
					break;
			}
		}
		if ( is_array($res['results']) ) {
			$tpl->parse(PageB, "search");
			$tpl->parse(PageB, ".search-result1");
			foreach ( $res['results'] as $idx => $val ) {
				$tpl->assign($val);
				$tpl->parse(PageB, ".search-result2");
			}
			$tpl->assign($res['vars']);
			$time_stop = getmicrotime();
			$SearchBenchmark = $time_stop - $time_start;
			$tpl->assign(SearchBenchmark, $SearchBenchmark);
			$tpl->parse(PageB, ".search-result3");
		} else {
			$tpl->parse(PageB, "search");
			$tpl->parse(PageB, ".search-noresults");
		}
	}
	break;
  case "admin":
	if ( isset($_SERVER['PHP_AUTH_USER']) ) {
		if ($_SERVER['PHP_AUTH_USER'] == $AdminUser && $_SERVER['PHP_AUTH_PW'] == $AdminPass) {
			$tpl->assign(PageTitle, "Administration Menu");
			if ( !isset($_POST['formaction']) ) {
				$tpl->parse(PageB, "admin");
						$query='SELECT * from ftps';
						$sql=sqlconnect($mysql);
						$result = mysql_query($query, $sql);
						$tpl->parse(PageB, ".admin-ftpmod1");
						while ($line = @mysql_fetch_array($result, MYSQL_ASSOC)) {
							$tpl->assign(id, $line['idx']);
							$ident ='ftp://' .decode($line[uss]);
							$ident.=':'      .decode($line[pas]);
							$ident.='@'      .decode($line[hos]);
							$ident.=':'      .decode($line[pos]);
							$tpl->assign(ident, $ident);
							$tpl->parse(PageB, ".admin-ftpmod2");
						}
						$tpl->parse(PageB, ".admin-ftpmod3");
			} else {
				switch ($_POST['adminaction']) {
					case 'doftp_mod':
						$tpl->assign(PageTitle, "Modify FTP");
						$query='SELECT * from ftps where idx='.$_POST['ftpsite'];
						$sql=sqlconnect($mysql);
						$result = mysql_query($query, $sql);
						$tpl->parse(PageB, ".admin-ftpmod1");
						$line = @mysql_fetch_array($result, MYSQL_ASSOC);
							$tpl->assign(idx, $line['idx']);
							$tpl->assign(email, decode($line[email]));
							$tpl->assign(user, decode($line[uss]));
							$tpl->assign(port, decode($line[pos]));
							$tpl->assign(host, decode($line[hos]));
							$tpl->assign(pass, decode($line[pas]));
							$tpl->assign(sch, $line[sch]);
							$tpl->assign(time, $line[time]);
							$tpl->assign(dirs, $line[dirs]);
							$tpl->assign(files, $line[files]);
							$tpl->assign(update, date("D M j G:i:s T Y", $line[upd]));
						$tpl->parse(PageB, "admin-doftpmod");
						break;
					case 'resetftp':
						$query ='update ftps set ';
						$query.='hos="'      .sanitize(encode($_POST['host'] )).'", ';
						$query.='pos="'      .sanitize(encode($_POST['port'] )).'", ';
						$query.='uss="'      .sanitize(encode($_POST['user'] )).'", ';
						$query.='pas="'      .sanitize(encode($_POST['pass'] )).'", ';
						$query.='sch="'      .sanitize(encode($_POST['sch']  )).'", ';
						if ( $_POST['updemail'] == 1 ) {
							$query.='upd="0", ';
						} else {
							if ( $_POST['forceupd'] == 1 ) {
								$query.='upd="1", ';
							}
						}
						$query.='email="'    .sanitize(encode($_POST['email'])).'" ';
						$query.='where idx='.sanitize(encode( $_POST['idx']  )).'';
						$sql=sqlconnect($mysql);
						$result = mysql_query($query, $sql);
						$tpl->assign(PageTitle, "Redirecting you now...");
						$tpl->assign(intropage, 'admin');
						$tpl->parse(PageB, "redirect");
						break;
					case 'deleteftp':
						if ( $_POST['iamfreakinpositive'] ) {
							$query='delete from ftps where idx="'.$_POST['idx'].'"'; 
							$sql=sqlconnect($mysql);
							$result = mysql_query($query, $sql);
							$query='delete from idx where IDXftp="'.$_POST['idx'].'"';
							$result = mysql_query($query, $sql);
						}
						$tpl->assign(PageTitle, "Redirecting you now...");
						$tpl->assign(intropage, 'admin');
						$tpl->parse(PageB, "redirect");
						break;
					case 'db_backup':
						set_time_limit(0);
						header("Content-Type: text");
						header("Content-Disposition: attachment; filename=indexer-backup-".time().".txt");
						$fp=popen($do_backup, 'r');
						while ( $data=fgets($fp, 4096) ) {
							echo $data;
							flush();
						}
						die();
					case 'file_remove':
						if ( $_POST['wildcard'] ) {
							$match='dstring REGEXP "'.$_POST['match'].'" ';
						} else {
							$match='dstring = "'.$_POST['match'].'" ';
						}
						if ( $_POST['files'] ) {
							$query1='select idx from files where '.$match;
							$sql=sqlconnect($mysql);
							$result = mysql_query($query1, $sql);
							while ($line = @mysql_fetch_array($result, MYSQL_ASSOC)) {
								$idx[]=$line['idx'];
							}
							if ( is_array($idx) ) {
								foreach ( $idx as $id ) {
									echo 'f '; flush();
									$query2='delete from files where idx='.$id;
									$query3='delete from idx where IDXfil='.$id;
									mysql_query($query2, $sql);
									mysql_query($query3, $sql);
								}
							}
						}
						if ( $_POST['dirs'] ) {
							$query1='select idx from dirs where '.$match;
							$sql=sqlconnect($mysql);
							$result = mysql_query($query1, $sql);
							while ($line = @mysql_fetch_array($result, MYSQL_ASSOC)) {
								$idx[]=$line['idx'];
							}
							if ( is_array($idx) ) {
								foreach ( $idx as $id ) {
									echo 'd '; flush();
									$query2='delete from dirs where idx='.$id;
									$query3='delete from idx where IDXdir='.$id;
									mysql_query($query2, $sql);
									mysql_query($query3, $sql);
								}
							}
						}
						$tpl->assign(PageTitle, "Redirecting you now...");
						$tpl->assign(intropage, 'admin');
						$tpl->parse(PageB, "redirect");
						break;

					default:
						break;
				}
			}
		} else {
			header('WWW-Authenticate: Basic realm="Please Authenticate"');
			header('HTTP/1.0 401 Unauthorized');
			exit;
		}
	} else {
		header('WWW-Authenticate: Basic realm="Please Authenticate"');
		header('HTTP/1.0 401 Unauthorized');
		exit;
	}
	break;
  default:
	$tpl->assign(PageTitle, "Redirecting you to the default intro page");
	$tpl->assign(intropage, $Defaults['intropage']);
	$tpl->parse(PageB, "redirect");
 };

 $tpl->parse(PageH, "header");
 $tpl->parse(PageF, "footer");
 $tpl->FastPrint(PageH);
 $tpl->FastPrint(PageB);
 $tpl->FastPrint(PageF);
?>
