<?php

 ########################################################################################
 # $indexer['debug'] turns debugging output iether on, or off (1, or 0)  Unless you     #
 # really want 4 million lines of debugging information, you probably wan to set this   #
 # to 0. P.S. -- sorry, i forgot to add this in the first official 2.0 release...       #
$indexer['debug']=0;#####################################################################

 ########################################################################################
 # The $indexer[timeout] is used to tell php how long to let the indexer live.  this    #
 # number gets boosted through every loop (by $indexer[timeoutinc] below.) So if (for   #
 # some reason) the indexer stops working properly php will time the script out and end #
 # its execution (rather than letting it run errantly for the rest of eternity          #
$indexer[timeout]    = 300;##############################################################

 ########################################################################################
 # The number of "pseudo threads" the indexer script will use... if this number is set  #
 # too high some connections to ftps may be dropped (because of inactivity timeouts)    #
$indexer[threads]    = 2;################################################################

 ########################################################################################
 # Here you can induce 'fake lag' into the indexer. you force the indexer to slow down  #
 # which should make the sysadmins who work for your provider happier with my work :D   #
 # this number is measuerd in microseconts (so a setting of 1000000 will cause the      #
 # the script to wait one second after certain actions)                                 #
$indexer[lag]        = 0;################################################################

 ########################################################################################
 # As mentioned above we are increasing the time that php should let this script live.. #
 # so each time a loop action has been completed php will let the script live (by de-   #
 # fault) an extra 90 seconds.  This is to prevent the indexer from being terminated by #
 # php when it's still fuctioning properly                                              #
$indexer[timeoutinc] = 90;###############################################################

 ########################################################################################
 # After the indexer has finished with its current batch of ftps it shuts down for a    #
 # while and takes a nap (no use annoying your sysadmins) this options defines, in a    #
 # number of seconds, how long that nap is to take                                      #
$indexer[sleep]      = 10;###############################################################

 ########################################################################################
 # There are two modes that the indexer itself may be run in.  My preferred mode of     #
 # opertion is in "daemon" mode (a daemon is a program that sits in the background doing#
 # its thing when nessecary on its own), the alternative method of operation is "cron"  #
 # mode, where the script runs when called, and terminates as soon as it's done.  Each  #
 # has its uses as described in the users manual.  1 means "Daemon", 0 means "Cron"     #
$indexer[daemon]     = 1;################################################################

 ########################################################################################
 # Time (in seconds) an ftp's index lasts by default.  after which it will be  ellige-  #
 # able for reindexing                                                                  #
$indexer[lifespan]   = 259200;###########################################################

 ########################################################################################
 # The number of seconds to wait before trying to reconnect to an FTP site that we have #
 # lost communications to.                                                              #
$indexer['sleepretry'] = 30;#############################################################

 ########################################################################################
 # The number of times to attempt to reconnect to an FTP that we've lost comminucation  #
 # to.  Remember that during these retries (and the wait between retries) we are NOT    #
 # processing other threads... so... use with caution                                   #
$indexer['retry'] = 5;###################################################################

 ########################################################################################
 # $indexer['notify'] is used to hard code e-mail notifications.  when an FTP is first  #
 # submitted, the user who submitted it can pick a place for their notification to go   #
 # but this will allow you, as an administrator to specify as many e-mail addresses as  #
 # you wish to recieve notifications upon a successful indexing venture as you wish     #
 # $indexer['notify'][] = 'ftp-announce-list@apokalyptik.com';                          #
 # $indexer['notify'][] = 'interested_party@apokalyptik.com';                           #
$indexer['notify'][]    = 'apokalyptik@apokalyptik.com';#################################

 ########################################################################################
 # setting $indexer['matchfiles'] to 1 requires the indexer to run a series of checks   #
 # (configurable below) before adding a file to the index.  If the file fails any of    #
 # the checks, then it is skipped over, and never added to the database.  set this opt- #
 # ion to 0 to disable this filtering feature                                           #
$indexer['matchfiles']  = 0;#############################################################

 ########################################################################################
 # setting $indexer['matchdirs'] to one tells the indexer to match against directory    #
 # names on the ftp servers that it connects to.  if a directory name is matched, then  #
 # ALL files inside it will be skipped over.  it's important to note that unless the    #
 # $indexer['matchwild'] is set to 1 this is an EXACT match (except that it is case in- #
 # sensitive).  so a match for '/tmp/' would stop files in /tmp/ from being indexed,    #
 # but /tpm/moretemp/ would be fair game.  also note that a preceeding and trailing '/' #
 # is REQUIRED to match a directory if $indexer['matchwild'] is set to 0                #
$indexer['matchdirs']   = 0;#############################################################

 ########################################################################################
 # setting $indexer['matchwild?'] to 1 will cause the configured matches to be matched  #
 # wildcards.  This means that a "gz" match will match "/gz/directory/" or "gzip.Z".    #
 # setting this option to 0 causes complete matches ONLY to be matched. So - a match    #
 # for porn.jpg would only match porn.jpg, not more-porn.jpg (case insensitive), and    #
 # /tmp/ would only match the /tmp/ directory, and not /files/tmp/scratch/              #
 # $indexer['matchwildf'] sets wildcard matching on files, and $indexer['matchwildd']   #
 # sets wildcard matching on directories.                                               #
$indexer['matchwildf']   = 0;                                                           #
$indexer['matchwildd']   = 0;############################################################

 ########################################################################################
 # $indexer['match'] is an array of strings to be used by the indexer to discard files  #
 # that the site-admin deams to be "innapropriate."  Depending on how the options above #
 # have been configured, these will behave in certain ways.  This list matches against  #
 # both directories and file names                                                      #
$indexer['match'][]     = 'gz';                                                         #
$indexer['match'][]     = 'tmp';#########################################################

?>
